"use strict";
// Copyright IBM Corp. 2018,2019. All Rights Reserved.
// Node module: @loopback/example-rpc-server
// This file is licensed under the MIT License.
// License text available at https://opensource.org/licenses/MIT
Object.defineProperty(exports, "__esModule", { value: true });
const tslib_1 = require("tslib");
const context_1 = require("@loopback/context");
const core_1 = require("@loopback/core");
const express_1 = tslib_1.__importDefault(require("express"));
const p_event_1 = tslib_1.__importDefault(require("p-event"));
const rpc_router_1 = require("./rpc.router");
let RPCServer = class RPCServer extends context_1.Context {
    constructor(app, config) {
        super(app);
        this.app = app;
        this.config = config;
        this._listening = false;
        this.config = config !== null && config !== void 0 ? config : {};
        this.expressServer = express_1.default();
        rpc_router_1.rpcRouter(this);
    }
    get listening() {
        return this._listening;
    }
    async start() {
        this._server = this.expressServer.listen((this.config && this.config.port) || 3000);
        this._listening = true;
        return p_event_1.default(this._server, 'listening');
    }
    async stop() {
        this._server.close();
        this._listening = false;
        return p_event_1.default(this._server, 'close');
    }
};
RPCServer = tslib_1.__decorate([
    tslib_1.__param(0, context_1.inject(core_1.CoreBindings.APPLICATION_INSTANCE)),
    tslib_1.__param(1, context_1.inject('rpcServer.config')),
    tslib_1.__metadata("design:paramtypes", [core_1.Application, Object])
], RPCServer);
exports.RPCServer = RPCServer;
//# sourceMappingURL=rpc.server.js.map